<?php

/* NB: In Adobe Connect: set "use e-mail as login" to No in the Administration interface for "Users and Groups" */
/* NB: In shibboleth AAP.xml add "espeeUid" as Shib-espeeUid attribute as set by espee-test */
/* NB: In C:\breeze\custom.ini change HTTP_AUTH_HEADER to shib-espeeuid */

/* TODO: error handling: generic check of status code */

#require_once('/home/hansz/coin/trunk/Grouper/PHP/grouper-functions.php');
#require_once('/home/hansz/coin/trunk/Grouper/PHP/grouper-configs.php');

define('ENV_VAR_MAIL', 'Shib_InetOrgPerson_mail');
define('ENV_VAR_GIVENNAME', 'Shib_InetOrgPerson_givenName');
define('ENV_VAR_SURNAME', 'Shib_Person_surname');
define('ENV_VAR_INSTELLING', 'Shib_SN_Instelling');
define('ENV_VAR_UID', 'Shib_InetOrgPerson_uid');


$config = array(
	'url' => 'http://meeting1.coin.surfnetlabs.nl/api/xml',
	'admin' => array(
		'login' => '[USERNAMEHERE]',
		'password' => '[PASSWORDHERE]',
	),
);

function connect_curl_init() {
	global $ch;
	if ($ch == NULL) {
		$cookie_file = "/tmp/cookie1.txt";
		@unlink($cookie_file);
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
#		curl_setopt($ch, CURLOPT_VERBOSE, TRUE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_COOKIEJAR, $cookie_file);
		curl_setopt($ch, CURLOPT_COOKIEFILE, $cookie_file);
	}
	return $ch;
}

function connect_call($url) {
	$ch = connect_curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	$result = curl_exec($ch);
	if ($result == FALSE) die(curl_error($ch));
	return $result;
}

function connect_action($cfg, $action) {
	$url = $cfg['url'] . '?' . 'action=' . urlencode($action);
	return connect_call($url);
}

function connect_principal_list($cfg, $name, $type = 'user') {
	$url = $cfg['url'] . '?' . 'action=principal-list';
	if (isset($name)) {
		if ($type === 'user') {
			$url .= '&filter-login=' . urlencode($name);
		} else if ($type === 'group') {
			$url .= '&filter-type=group&filter-name=' . urlencode($name);
		}
	}
	return connect_call($url);
}

function connect_login($cfg, $user, $password) {
	$url = $cfg['url'] . '?action=login&login=' . urlencode($user) . '&password=' . urlencode($password);
	# . '&session=' . 'breez6mtwsdqwkdo2iuoa';
	return connect_call($url);
}

function connect_user_create($cfg, $user, $password, $firstname, $lastname, $email) {
	$url = $cfg['url'] .
		'?action=principal-update' .
		'&first-name=' . urlencode($firstname) .
		'&last-name=' . urlencode($lastname) .
		'&login=' . urlencode($user) .
		'&email=' . urlencode($email) .
		'&password=' . urlencode($password) .
		'&type=user' .
		'&has-children=0';
	return connect_call($url);
}

function connect_user_exists($cfg, $user) {
	$r = simplexml_load_string(connect_principal_list($cfg, $user));
	return ( isset($r->{'principal-list'}->principal['principal-id']) );
}

function connect_group_exists($cfg, $name) {
	$r = simplexml_load_string(connect_principal_list($cfg, $name, 'group'));
	return ( isset($r->{'principal-list'}->principal['principal-id']) );
}

function connect_delete_principal($cfg, $id) {
	$url = $cfg['url'] .
    		'?action=principals-delete' .
		'&principal-id=' . urlencode($id);
	return connect_call($url);
}

function connect_login_delete($cfg, $login) {
	$result = connect_principal_list($cfg, $login);
	$r = simplexml_load_string($result);
	$id = $r->{'principal-list'}->principal['principal-id'];
	$result = connect_delete_principal($cfg, $id);
	return $result;
}

function connect_create_group($cfg, $name) {
	$url = $cfg['url'] .
		'?action=principal-update' .
		'&type=group' .
		'&has-children=1' .
		'&name=' . urlencode($name);
	return connect_call($url);
}

function helper_script_env($env_var_name) {
	if (array_key_exists($env_var_name, $_ENV)) {
		return $_ENV[$env_var_name];
	}
	throw new Exception($env_var_name . ' does not exist');
}

function retrieve_script_environment() {
	$result = array();
	$result['mail'] = helper_script_env(ENV_VAR_MAIL);
	$result['givenname'] = helper_script_env(ENV_VAR_GIVENNAME);
	$result['surname'] = helper_script_env(ENV_VAR_SURNAME);
	$result['instelling']  = helper_script_env(ENV_VAR_INSTELLING);
	$result['uid']  = helper_script_env(ENV_VAR_UID);
	$result['login'] = $result['instelling'] . '.' . $result['uid'];
	return $result;
}

function connect_login_admin($cfg) {
	connect_login($cfg, $cfg['admin']['login'], $cfg['admin']['password']);
}

function connect_group_get_id($cfg, $name) {
	$id = NULL;
	$r = simplexml_load_string(connect_principal_list($cfg, $name, 'group'));
	if ( isset($r->{'principal-list'}->principal['principal-id']) ) {
		$id = $r->{'principal-list'}->principal['principal-id'];
	}
	return $id;
}

function connect_group_create($cfg, $name) {
	$id = connect_group_get_id($cfg, $name);
	if ($id == NULL) {
		$result = connect_create_group($cfg, $name);
		$r = simplexml_load_string($result);
		#print_r($r);
		$id = $r->principal['principal-id'];
	}
	return $id;
}

function connect_group_delete($cfg, $name) {
	$id = connect_group_get_id($cfg, $name);
	if ($id != NULL) {
		$result = connect_delete_principal($cfg, $id);
		print_r($result);
	} else {
		print 'group "' . $name . '" could not be found' . "\n";
	}
}

function connect_command($cfg) {
	global $argv;
	switch ($argv[1]) {
		case 'create-user':
			connect_login_admin($cfg);
			#$result = connect_user_create($cfg, $argv[2]);
 			$result = connect_user_create($cfg, $argv[2], '77c4ff167a874160a010cff792c20226', 'Givenname', 'Surname', 'Mail@surfnet.nl');
			print_r($result);
			break;
		case 'delete-user':
			connect_login_admin($cfg);
			$result = connect_login_delete($cfg, $argv[2]);
			print_r($result);
			break;
		case 'create-group':
			connect_login_admin($cfg);
			$result = connect_group_create($cfg, $argv[2]);
			print_r($result);
			break;
		case 'delete-group':
			connect_login_admin($cfg);
			$result = connect_group_delete($cfg, $argv[2]);
			print_r($result);
			break;
		case 'list':
			connect_login_admin($cfg);
			$result = connect_action($cfg, 'principal-list');
			print_r(simplexml_load_string($result));
			break;
		case 'info':
			$result = connect_action($cfg, 'common-info');
			print_r(simplexml_load_string($result));
			break;	
		default:
			print "unknown command: " . $argv[1] . "\n";
			break;
	}
}

if (sizeof($argv) > 1) {
	// assume this script is called from the commandline for maintenance/testing purposes
	connect_command($config);
	exit;
}

// assume this is called from the Apache Proxy:
// perform automatic provisioning of the user (and groups/rooms)

// retrieve the attributes from the environment (cgi/shibboleth)
$env = retrieve_script_environment();

// login as admin
connect_login_admin($config);

// check if the user already exists
$result = connect_user_exists($config, $env['login']);
if ($result === FALSE) {

	// user does not exist: create the user
 	$result = connect_user_create($config, $env['login'], '77c4ff167a874160a010cff792c20226', $env['givenname'], $env['surname'], $env['mail']);
}

// test grouper/groups stuff
#$cfg = $grouper_configs['knikker'];
#grouper_init($cfg);
#$groups = grouper_get_groups($cfg, $env['login']);
#foreach ($groups as $group) {
#}

?>
